VTK: vtkDirectory Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkDirectory Class Reference

OS independent class for access and manipulation of system directories. More...

`#include <vtkDirectory.h>`

Inheritance diagram for vtkDirectory:
[legend]
Collaboration diagram for vtkDirectory:
[legend]

## Public Member Functions
void | PrintSelf (ostream &os, vtkIndent indent) override
| Print directory to stream. More...
int | Open (VTK_FILEPATH const char *dir)
| Open the specified directory and load the names of the files in that directory. More...
vtkIdType | GetNumberOfFiles ()
| Return the number of files in the current directory. More...
VTK_FILEPATH const char * | GetFile (vtkIdType index)
| Return the file at the given index, the indexing is 0 based. More...
int | FileIsDirectory (VTK_FILEPATH const char *name)
| Return true if the file is a directory. More...
virtual vtkStringArray * | GetFiles ()
| Get an array that contains all the file names. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkDirectory * | New ()
| Create a new vtkDirectory object. More...
static VTK_FILEPATH const char * | GetCurrentWorkingDirectory (char *buf, unsigned int len)
| Get the current working directory. More...
static int | MakeDirectory (VTK_FILEPATH const char *dir)
| Create directory. More...
static int | DeleteDirectory (VTK_FILEPATH const char *dir)
| Remove a directory. More...
static int | Rename (VTK_FILEPATH const char *oldname, VTK_FILEPATH const char *newname)
| Rename a file or directory. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
void | CleanUpFilesAndPath ()
| vtkDirectory ()
| ~vtkDirectory () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)
typedef vtkObject | Superclass
| Return the class name as a string. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Return the class name as a string. More...
static vtkDirectory * | SafeDownCast (vtkObjectBase *o)
| Return the class name as a string. More...
virtual vtkTypeBool | IsA (const char *type)
| Return the class name as a string. More...
vtkDirectory * | NewInstance () const
| Return the class name as a string. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Return the class name as a string. More...

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

OS independent class for access and manipulation of system directories.

vtkDirectory provides a portable way of finding the names of the files in a system directory. It also provides methods of manipulating directories.

Warning
  vtkDirectory works with windows and unix only.

Online Examples:

Tests:
  vtkDirectory (Tests)

Definition at line 35 of file vtkDirectory.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkDirectory::Superclass

Return the class name as a string.

Definition at line 42 of file vtkDirectory.h.

## Constructor & Destructor Documentation

## ◆ vtkDirectory()

vtkDirectory::vtkDirectory | ( |  | ) |
| protected

## ◆ ~vtkDirectory()

vtkDirectory::~vtkDirectory | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkDirectory::IsTypeOf | ( | const char * | type | ) |
| static

Return the class name as a string.

## ◆ IsA()

virtual vtkTypeBool vtkDirectory::IsA | ( | const char * | type | ) |
| virtual

Return the class name as a string.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkDirectory* vtkDirectory::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Return the class name as a string.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkDirectory::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Return the class name as a string.

## ◆ NewInstance()

vtkDirectory* vtkDirectory::NewInstance | ( |  | ) | const

Return the class name as a string.

## ◆ New()

static vtkDirectory* vtkDirectory::New | ( |  | ) |
| static

Create a new vtkDirectory object.

## ◆ PrintSelf()

void vtkDirectory::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Print directory to stream.

Reimplemented from vtkObject.

## ◆ Open()

int vtkDirectory::Open | ( | VTK_FILEPATH const char * | dir | ) |

Open the specified directory and load the names of the files in that directory.

0 is returned if the directory can not be opened, 1 if it is opened.

## ◆ GetNumberOfFiles()

vtkIdType vtkDirectory::GetNumberOfFiles | ( |  | ) |

Return the number of files in the current directory.

## ◆ GetFile()

VTK_FILEPATH const char* vtkDirectory::GetFile | ( | vtkIdType | index | ) |

Return the file at the given index, the indexing is 0 based.

## ◆ FileIsDirectory()

int vtkDirectory::FileIsDirectory | ( | VTK_FILEPATH const char * | name | ) |

Return true if the file is a directory.

If the file is not an absolute path, it is assumed to be relative to the opened directory. If no directory has been opened, it is assumed to be relative to the current working directory.

## ◆ GetFiles()

virtual vtkStringArray* vtkDirectory::GetFiles | ( |  | ) |
| virtual

Get an array that contains all the file names.

## ◆ GetCurrentWorkingDirectory()

static VTK_FILEPATH const char* vtkDirectory::GetCurrentWorkingDirectory | ( | char * | buf,
|  | unsigned int | len
| ) |  |
| static

Get the current working directory.

## ◆ MakeDirectory()

static int vtkDirectory::MakeDirectory | ( | VTK_FILEPATH const char * | dir | ) |
| static

Create directory.

## ◆ DeleteDirectory()

static int vtkDirectory::DeleteDirectory | ( | VTK_FILEPATH const char * | dir | ) |
| static

Remove a directory.

## ◆ Rename()

static int vtkDirectory::Rename | ( | VTK_FILEPATH const char * | oldname,
|  | VTK_FILEPATH const char * | newname
| ) |  |
| static

Rename a file or directory.

## ◆ CleanUpFilesAndPath()

void vtkDirectory::CleanUpFilesAndPath | ( |  | ) |
| protected

The documentation for this class was generated from the following file:

- Common/System/vtkDirectory.h